
package knapsack;

/**
 * Knapsack item.
 *
 * @author	Copyright (C) 2002 Alessandro Bollini
 */
public class Item {

	private final String name;

	private final int weight; // [kg]
	private final int volume; // [lt]
	private final int value; // [euro]


	public Item(
		final String name,
		final int weight, int volume, int value) {

		if ( name == null || name.trim().length() == 0 ) {
			throw new IllegalArgumentException("null or emty name");
		}

		if ( weight <= 0 ) {
			throw new IllegalArgumentException("negative or null weight");
		}

		if ( volume <= 0 ) {
			throw new IllegalArgumentException("negative or null volume");
		}

		if ( value < 0 ) {
			throw new IllegalArgumentException("negative value");
		}

		this.name=name;
		this.weight=weight;
		this.volume=volume;
		this.value=value;
	}


	public String getName() {
		return name;
	}

	public int getWeight() {
		return weight;
	}

	public int getVolume() {
		return volume;
	}

	public int getValue() {
		return value;
	}

	public String toString() {
		return "[item name="+name
			+", weight="+weight+", volume="+volume+", value="+value;
	}
}
